Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 65253)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 65254)
@@ -60,5 +60,4 @@
 
 
-
 /** QIStateStatusBarIndicator extension for Runtime UI. */
 class UISessionStateStatusBarIndicator : public QIWithRetranslateUI<QIStateStatusBarIndicator>
@@ -69,5 +68,11 @@
 
     /** Constructor which remembers passed @a session object. */
-    UISessionStateStatusBarIndicator(UISession *pSession) : m_pSession(pSession) {}
+    UISessionStateStatusBarIndicator(IndicatorType enmType, UISession *pSession)
+        : m_enmType(enmType)
+        , m_pSession(pSession)
+    {}
+
+    /** Returns the indicator type. */
+    IndicatorType type() const { return m_enmType; }
 
     /** Abstract update routine. */
@@ -75,4 +80,7 @@
 
 protected:
+
+    /** Holds the indicator type. */
+    const IndicatorType m_enmType;
 
     /** Holds the session UI reference. */
@@ -89,5 +97,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorHardDrive(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_HardDisks, pSession)
     {
         /* Assign state-icons: */
@@ -162,5 +170,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorOpticalDisks(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_OpticalDisks, pSession)
     {
         /* Assign state-icons: */
@@ -239,5 +247,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorFloppyDisks(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_FloppyDisks, pSession)
     {
         /* Assign state-icons: */
@@ -316,5 +324,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorNetwork(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_Network, pSession)
         , m_pTimerAutoUpdate(0)
         , m_cMaxNetworkAdapters(0)
@@ -466,5 +474,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorUSB(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_USB, pSession)
     {
         /* Assign state-icons: */
@@ -532,5 +540,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorSharedFolders(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_SharedFolders, pSession)
     {
         /* Assign state-icons: */
@@ -603,5 +611,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorDisplay(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_Display, pSession)
     {
         /* Assign state-icons: */
@@ -685,5 +693,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorVideoCapture(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_VideoCapture, pSession)
         , m_pAnimation(0)
         , m_dRotationAngle(0)
@@ -807,5 +815,5 @@
     /** Constructor, passes @a pSession to the UISessionStateStatusBarIndicator constructor. */
     UIIndicatorFeatures(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_Features, pSession)
     {
         /* Assign state-icons: */
@@ -892,5 +900,5 @@
     /** Constructor, using @a pSession for state-update routine. */
     UIIndicatorMouse(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_Mouse, pSession)
     {
         /* Assign state-icons: */
@@ -952,5 +960,5 @@
     /** Constructor, using @a pSession for state-update routine. */
     UIIndicatorKeyboard(UISession *pSession)
-        : UISessionStateStatusBarIndicator(pSession)
+        : UISessionStateStatusBarIndicator(IndicatorType_Keyboard, pSession)
     {
         /* Assign state-icons: */