Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 65272)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 65273)
@@ -63,10 +63,10 @@
 
 /* static */
-UIVMInformationDialog* UIVMInformationDialog::m_spInstance = 0;
+UIVMInformationDialog* UIVMInformationDialog::s_pInstance = 0;
 
 void UIVMInformationDialog::invoke(UIMachineWindow *pMachineWindow)
 {
     /* Make sure dialog instance exists: */
-    if (!m_spInstance)
+    if (!s_pInstance)
     {
         /* Create new dialog instance if it doesn't exists yet: */
@@ -75,11 +75,11 @@
 
     /* Show dialog: */
-    m_spInstance->show();
+    s_pInstance->show();
     /* Raise it: */
-    m_spInstance->raise();
+    s_pInstance->raise();
     /* De-miniaturize if necessary: */
-    m_spInstance->setWindowState(m_spInstance->windowState() & ~Qt::WindowMinimized);
+    s_pInstance->setWindowState(s_pInstance->windowState() & ~Qt::WindowMinimized);
     /* And activate finally: */
-    m_spInstance->activateWindow();
+    s_pInstance->activateWindow();
 }
 
@@ -90,5 +90,5 @@
 {
     /* Initialize instance: */
-    m_spInstance = this;
+    s_pInstance = this;
 
     /* Prepare: */
@@ -102,5 +102,5 @@
 
     /* Deinitialize instance: */
-    m_spInstance = 0;
+    s_pInstance = 0;
 }
 
@@ -112,9 +112,6 @@
 void UIVMInformationDialog::retranslateUi()
 {
-    CMachine machine = gpMachine->uisession()->machine();
-    AssertReturnVoid(!machine.isNull());
-
     /* Setup dialog title: */
-    setWindowTitle(tr("%1 - Session Information").arg(machine.GetName()));
+    setWindowTitle(tr("%1 - Session Information").arg(m_pMachineWindow->machine().GetName()));
 
     /* Translate tabs: */
@@ -126,5 +123,5 @@
 {
     /* Pre-process through base-class: */
-    bool fResult = QIMainWindow::event(pEvent);
+    const bool fResult = QIMainWindow::event(pEvent);
 
     /* Process required events: */
@@ -195,7 +192,4 @@
     prepareCentralWidget();
 
-    /* Assign tab-widget page change handler: */
-    connect(m_pTabWidget, SIGNAL(currentChanged(int)), this, SLOT(sltHandlePageChanged(int)));
-
     /* Retranslate: */
     retranslateUi();
@@ -222,8 +216,4 @@
 void UIVMInformationDialog::prepareTabWidget()
 {
-    /* List of VM items: */
-    QList<UIVMItem*> items;
-    items << new UIVMItem(gpMachine->uisession()->machine());
-
     /* Create tab-widget: */
     m_pTabWidget = new QITabWidget;
@@ -234,25 +224,30 @@
         m_pTabWidget->setTabIcon(1, UIIconPool::iconSet(":/session_info_runtime_16px.png"));
 
+        /* Create Configuration Details tab: */
+        UIInformationConfiguration *pInformationConfigurationWidget =
+            new UIInformationConfiguration(this, m_pMachineWindow->machine(), m_pMachineWindow->console());
+        AssertPtrReturnVoid(pInformationConfigurationWidget);
+        {
+            m_tabs.insert(0, pInformationConfigurationWidget);
+            m_pTabWidget->addTab(m_tabs.value(0), QString());
+        }
+
+        /* Create Runtime Information tab: */
+        UIInformationRuntime *pInformationRuntimeWidget =
+            new UIInformationRuntime(this, m_pMachineWindow->machine(), m_pMachineWindow->console());
+        AssertPtrReturnVoid(pInformationRuntimeWidget);
+        {
+            m_tabs.insert(1, pInformationRuntimeWidget);
+            m_pTabWidget->addTab(m_tabs.value(1), QString());
+        }
+
+        /* Set Runtime Information tab as default: */
+        m_pTabWidget->setCurrentIndex(1);
+
+        /* Assign tab-widget page change handler: */
+        connect(m_pTabWidget, SIGNAL(currentChanged(int)), this, SLOT(sltHandlePageChanged(int)));
+
         /* Add tab-widget into main-layout: */
         centralWidget()->layout()->addWidget(m_pTabWidget);
-
-        /* Create Configuration Details tab: */
-        UIInformationConfiguration *pInformationConfigurationWidget = new UIInformationConfiguration(this, gpMachine->uisession()->machine(), gpMachine->uisession()->console());
-        AssertPtrReturnVoid(pInformationConfigurationWidget);
-        {
-            m_tabs.insert(0, pInformationConfigurationWidget);
-            m_pTabWidget->addTab(m_tabs.value(0), QString());
-        }
-
-        /* Create Runtime Information tab: */
-        UIInformationRuntime *pInformationRuntimeWidget = new UIInformationRuntime(this, gpMachine->uisession()->machine(), gpMachine->uisession()->console());
-        AssertPtrReturnVoid(pInformationRuntimeWidget);
-        {
-            m_tabs.insert(1, pInformationRuntimeWidget);
-            m_pTabWidget->addTab(m_tabs.value(1), QString());
-        }
-
-        /* Set Runtime Information tab as default: */
-        m_pTabWidget->setCurrentIndex(1);
     }
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.h	(revision 65272)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.h	(revision 65273)
@@ -29,6 +29,6 @@
 /* Forward declarations: */
 class QITabWidget;
+class QIDialogButtonBox;
 class UIMachineWindow;
-class QIDialogButtonBox;
 
 
@@ -93,5 +93,5 @@
      * @{ */
     /** Holds the dialog instance. */
-    static UIVMInformationDialog *m_spInstance;
+    static UIVMInformationDialog *s_pInstance;
     /** @} */
 
@@ -99,11 +99,11 @@
      * @{ */
     /** Holds the dialog tab-widget instance. */
-    QITabWidget               *m_pTabWidget;
+    QITabWidget                  *m_pTabWidget;
     /** Holds the map of dialog tab instances. */
-    QMap<int, QWidget*>        m_tabs;
+    QMap<int, QWidget*>           m_tabs;
     /** Holds the dialog button-box instance. */
-    QIDialogButtonBox         *m_pButtonBox;
+    QIDialogButtonBox            *m_pButtonBox;
     /** Holds the machine-window reference. */
-    UIMachineWindow         *m_pMachineWindow;
+    UIMachineWindow              *m_pMachineWindow;
     /** @} */
 };