Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationConfiguration.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationConfiguration.cpp	(revision 65336)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationConfiguration.cpp	(revision 65337)
@@ -26,4 +26,5 @@
 /* GUI includes: */
 # include "UIInformationConfiguration.h"
+# include "UIInformationDataItem.h"
 # include "UIInformationItem.h"
 # include "UIInformationView.h"
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationModel.cpp	(revision 65336)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationModel.cpp	(revision 65337)
@@ -20,16 +20,5 @@
 #else  /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
-/* Qt includes: */
-# include <QFont>
-# include <QHash>
-# include <QBrush>
-# include <QGraphicsView>
-# include <QGraphicsScene>
-# include <QGraphicsSceneContextMenuEvent>
-
 /* GUI includes: */
-# include "VBoxGlobal.h"
-# include "UIConverter.h"
-# include "UIExtraDataManager.h"
 # include "UIInformationModel.h"
 # include "UIInformationDataItem.h"
@@ -53,5 +42,5 @@
 }
 
-int UIInformationModel::rowCount(const QModelIndex& /*parent */) const
+int UIInformationModel::rowCount(const QModelIndex & /* parentIndex */) const
 {
     /* Return row-count: */
@@ -61,8 +50,6 @@
 QVariant UIInformationModel::data(const QModelIndex &index, int role) const
 {
-    /* Get row: */
-    int row = index.row();
     /* Get item at the row: */
-    UIInformationDataItem *pItem = m_list.at(row);
+    UIInformationDataItem *pItem = m_list.at(index.row());
     /* Return the data for the corresponding role: */
     return pItem->data(index, role);
@@ -77,8 +64,8 @@
 }
 
-void UIInformationModel::updateData(const QModelIndex &idx)
+void UIInformationModel::updateData(const QModelIndex &index)
 {
     /* Emit data-changed signal: */
-    emit dataChanged(idx, idx);
+    emit dataChanged(index, index);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationModel.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationModel.h	(revision 65336)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationModel.h	(revision 65337)
@@ -20,25 +20,10 @@
 
 /* Qt includes: */
-#include <QMap>
-#include <QSet>
-#include <QObject>
-#include <QPointer>
 #include <QAbstractListModel>
 
-/* GUI includes: */
-#include "UIExtraDataDefs.h"
-#include "UIInformationDataItem.h"
-
 /* COM includes: */
-# include "CGuest.h"
+# include "COMEnums.h"
 # include "CConsole.h"
-# include "CDisplay.h"
 # include "CMachine.h"
-# include "COMEnums.h"
-# include "CNetworkAdapter.h"
-# include "CMachineDebugger.h"
-# include "CMediumAttachment.h"
-# include "CSystemProperties.h"
-# include "CStorageController.h"
 
 /* Forward declarations: */
@@ -61,9 +46,9 @@
     ~UIInformationModel();
 
-    /** Returns the row-count for item specified by the @a parentIdx. */
-    int rowCount(const QModelIndex &parentIdx = QModelIndex()) const;
+    /** Returns the row-count for item specified by the @a parentIndex. */
+    virtual int rowCount(const QModelIndex &parentIndex = QModelIndex()) const /* override */;
 
     /** Returns the data for item specified by the @a index and the @a role. */
-    QVariant data(const QModelIndex &idx, int role = Qt::DisplayRole) const;
+    virtual QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const /* override */;
 
     /** Adds the @a pItem into the model. */
@@ -71,5 +56,5 @@
 
     /** Updates the data for item specified by the @a index. */
-    void updateData(const QModelIndex &idx);
+    void updateData(const QModelIndex &index);
 
 public slots:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 65336)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 65337)
@@ -26,4 +26,5 @@
 /* GUI includes: */
 # include "UIInformationRuntime.h"
+# include "UIInformationDataItem.h"
 # include "UIInformationItem.h"
 # include "UIInformationView.h"